# Verstrkung bzw. Gewinn (dB) in Abhngigkeit von Uaus / Uein
# Autor: Volker Lange-Janson, 29. Oktober 1999
# Anmerkung: Die Nullen nach dem Komma (bzw. Punkt) sind notwendig,
# um die Rechengenauigkeit zu erhhen
f=20.0000000 # Faktor fr Spannungsverhltnisse
m =0.43429448 # Diesen Faktor rechnet den natrlichen Logarithmus
# in den Zehner-Logarithmus um. log steht hier fr den natrlichen
# Logarithmus. Eigentlich msste die Abkrzung ln lauten.
V(x)=f * log(x) * m
set dummy x  
set grid    # damit Sie ein Gitter sehen
show grid
set xtics 0,0.5,10 # Skalenbeschriftung fr x        
set ytics 0,1,20 # Skalenbeschriftung fr y
set yrange [0 : 20] # Gibt den darzustellenden Bereich fr die y-Achse an.
set xrange [0 : 10]    # Der dargestellte Bereich fr die x-Achse
set nolog
set nopolar
set samples 10000  # gibt die Anzahl der Punkte, die berechnet werden, an
set title "Verstrkung bzw. Gewinn (dB) in Abhngigkeit von Uaus / Uein"
# Angabe des Titels
set xlabel "Ausgangs-Spannung Uaus / Eingangs-Spannung Uein"
# Beschriftung fr die x-Achse
set ylabel "Verstrkung bzw. Gewinn in dB" # Beschriftung fr die y-Achse
set format x "%g"
set format y "%g"
show format
plot V(x)
# gibt an, welche Funktion(en) angezeigt werden soll(en).
pause -1 "Beenden?" # Leider immer notwendig, damit 
# das Diagramm stehen bleibt.



