# Das Verhltnis Ausgangsspannung zur Leerlaufspannung in Abhngigkeit vom Anpassungsma Ra/Ri
# Autor: Volker Lange-Janson, 15. September 1999
# Anmerkung: Die Nullen nach dem Komma (bzw. Punkt) sind notwendig, um die Rechengenauigkeit zu erhhen
P(x)=1/((1/x)+1)        
set dummy x  
set grid    # damit Sie ein Gitter sehen
show grid
set xtics 0,0.1,1         
set ytics 0,0.1,1
set nolog
set nopolar
set samples 10000  # gibt die Anzahl der Punkte, die berechnet werden an
set title "Das Verhltnis Ausgangsspannung zur Leerlaufspannung in Abhngigkeit vom Anpassungsma Ra/Ri" # Angabe des Titels
set xlabel "Ra/Ri"  # Beschriftung fr die x-Achse
set ylabel "Uaus / ULeer" # Beschriftung fr die y-Achse
set yrange [0 : 1] # Gibt den darzustellenden Bereich fr die y-Achse an.
set xrange [0 : 1]    # Der dargestellte Bereich fr die x-Achse
set format x "%g"
set format y "%g"
show format
plot P(x)  # gibt an, welche Funktionen angezeigt werden sollen.
pause -1 "Beenden?" # Leider immer notwendig, damit das Diagramm stehen bleibt.
# Herleitung Uaus = Ausgangsspannung, ULeer= Leerlaufspannung,
# Ri=Innenwiderstand, Ra=Last- oder Aussenwiderstand
# Uaus / ULeer = Ra / ( Ri + Ra)
# Uaus / ULeer = 1 / ( (Ri + Ra)/Ra) )
# Uaus / ULeer = 1 / ((Ri/Ra)+1)
# Uaus / ULeer = 1 / ( ( 1/((Ra/Ri)+1) )  )




