# Leistung Paus / Pmax in Abhngigkeit vom Anpassungsma Ra/Ri
# Autor: Volker Lange-Janson, 15. September 1999
# Anmerkung: Die Nullen nach dem Komma (bzw. Punkt) sind notwendig, um die Rechengenauigkeit zu erhhen
P(x)=(x/(1+x**2+2*x))*4          
set dummy x  
set grid    # damit Sie ein Gitter sehen
show grid
set xtics 0,1,20         
set ytics 0,0.1,1
set nolog
set nopolar
set samples 10000  # gibt die Anzahl der Punkte, die berechnet werden an
set title "Leistung Paus / Pmax in Abhngigkeit vom Anpassungsma Ra/Ri" # Angabe des Titels
set xlabel "Ra/Ri"  # Beschriftung fr die x-Achse
set ylabel "Paus / Pmax" # Beschriftung fr die y-Achse
set yrange [0 : 1] # Gibt den darzustellenden Bereich fr die y-Achse an.
set xrange [0 : 20 ]    # Der dargestellte Bereich fr die x-Achse
set format x "%g"
set format y "%g"
show format
plot P(x)  # gibt an, welche Funktionen angezeigt werden sollen.
pause -1 "Beenden?" # Leider immer notwendig, damit das Diagramm stehen bleibt.



