' ------------------------- alles oberhalb dieser Zeile lschen ------------
'
'               E M I T T E R F O L G E R B E R E C H N U N G
'
'   
'   
'
'Programm zur Berechnung einer Kollektorschaltung
'
DECLARE SUB bildko (p%)               'zeigt das Schaltbild, das bei p% begi.
DECLARE SUB Frage (ow, uw, a, z, f$)  'Eingabeprozedur mit Grenzwertkontrolle
DECLARE SUB awdh (zeile%, spalte%)    'zeigt die Adresse fr Verabschiedung
DECLARE SUB mitte (zeil%, text$)      'setzt den Text in die Mitte der Zeile
DECLARE FUNCTION e6! (b!)             'wandelt Werte in die E 6-Reihe um
DECLARE FUNCTION k (wert)             'rundet auf 2 Stellen hinter dem Komma
DECLARE FUNCTION e12! (a!)            'wandelt Werte in die E 12-Reihe um
DIM SHARED ro, ru, bb, a!, b!
nochmal:  'Neustart des Programms

CLS : d$ = "k"
COLOR 9, 0
mitte 1, "B E R E C H N U N G  E I N E R  K O L L E K T O R S C H A L T U N G"
COLOR 7, 0
an = 2
bildko 2      'zeigt das Schaltbild, welches in Zeile 2 anfngt.
'---------------------------- Anfang des Eingabeblocks ---------------------
mitte 14, "Speisespannung, Kollektorstrom und Stromverstrkungsfaktor:"
ruelps = 16   'plaziert den Anfang des Eingabeblocks
'-------------------------------- 1. Frage ---------------------------------
COLOR 28, 0: LOCATE an + 1, 42: PRINT "?                     ": COLOR 7, 0
CALL Frage(45, 2, ub, ruelps, "Wie hoch ist die Speisespannung in Volt?")
LOCATE an + 1: PRINT "                                     U+="; ub; "Volt"
'--------------------------------- 2. Frage ---------------------------------
COLOR 28, 0: LOCATE an + 3, 42: PRINT "?                     ": COLOR 7, 0
CALL Frage(1000, .05, ic, ruelps + 1, "Wie gro ist der Kollektorstr. in mA?")
LOCATE an + 3: PRINT "                      Ro           Ic="; ic; "mA"
'--------------------------------- 3. Frage ---------------------------------
COLOR 28, 0: LOCATE an + 7, 42: PRINT "?                    ": COLOR 7, 0
CALL Frage(500, 70, b, ruelps + 2, "Wie hoch ist das minimale ?")
LOCATE an + 7: PRINT "       Eingang              E   min.="; b;
'---------------------------- Rechnen macht Spa ----------------------------
si = .65                         'Schwellwertspannung von Silizium in Volt
sb = (.5 * ub) + si              'Spannung an der Basis in Volt
ro = (ub - sb) / ((11 * ic) / b) 'oberer Basisspannungsteilerwiderstand (k)
ru = sb / ((10 * ic) / b)        'unterer Basisspannungsteilerwiderstand (k)
pv = .5 * ub * ic                'Transistorverlustleistung in mW
' -------------------------- Verluschtleischtung darstelle -----------------
LOCATE 3: PRINT "         fu= 50 Hz   o  Pv="; k(pv); "mW"
'---Basiswiderstnde anzeigen, unerklrlich warum Zeile doppelt sein mu-----
LOCATE 6: PRINT "                                   Ro="; k(ro); d$
LOCATE 7: PRINT "                 Ce         C      Ru="; k(ru); d$
'------------------------------ schn weiterrechnen -------------------------
ie = ic + (ic / b)               'Ie = Ic + Ib  (mA)
re = .5 * ub / ie                'Emitterwiderstand (k)
LOCATE an + 8: PRINT "               o             o  Re="; e12(re); d$
'-----------------------------letzte Zeile lschen --------------------------
LOCATE ruelps + 3: PRINT SPACE$(80) 'entfernt die letzte Grenzwertanzeige
'------------------------------ wir rechnen weiter --------------------------
s = 36.5 * ic                    'Transistorsteilheit in (mA/V)  (ungefhr)
sk = 1 / (36.5 * ic)             'Kehrwert von S (V/mA)
rein = b * re                    'Eingangswiderstand ohne Basiswiderstnde
bb = (ro * ru) / (ro + ru)       'Basiswiderstnde par. (k)
rge = (bb * rein) / (bb + rein)  'Einganngswiderstand der ges. Schalt. (k)
ra = (re * sk) / (re + sk)       'Gesamtausgangswiderstand (k)
ck = 1000 / (200 * rge)          'Eingangskondensator (nF) bei 50 Hz Grenzfr.
umax = .5 * ub - .3            'max. Ausgangsspannung in Vs, unbelastet
umaxeff = umax * (1 / SQR(2))  'max. Ausgangsspannung in Veff, unbelastet
v = re / ((1 / s) + re)          ' Spannungsverstrkungsfaktor, unbelastet
eumax = v * umax           'max. Eingangsspannung in Vs, Ausgang unbelastet
eumaxeff = v * umaxeff     'max. Eingangsspannung in Veff, Ausgang unbelastet
'-------------------------------- Eingabefeld lschen ----------------------
FOR radier = 14 TO 20: LOCATE radier: PRINT SPACE$(80): NEXT radier
'-------------------------------Ergebnisse anzeigen ------------------------
COLOR 14, 0
mitte 14, "Ein- und Ausgangswiderstnde"
LOCATE 16: PRINT TAB(40); "Ausgangswiderstand:"; k(ra * 1000); ""
LOCATE 16: PRINT "Eingangswiderstand:"; k(rge); d$
LOCATE 17: PRINT TAB(40); "max. Ausgangspannung:"; k(umax); "Vs"
LOCATE 17: PRINT "max. Eingangsspannung:"; k(eumax); "Vs"
LOCATE 18: PRINT TAB(40); "Spannungsverstrkung:"; v
LOCATE 18: PRINT "Eingangskondensator:"; e6(ck); "nF"
LOCATE 6: PRINT SPACE$(80): LOCATE 7: PRINT SPACE$(80)
COLOR 7, 0
'----------------------- Basisspannungsteilerwiderstnde anzeigen ----------
LOCATE 6: PRINT "                                   Ro="; e12(ro); d$
LOCATE 7: PRINT "                 Ce         C      Ru="; e12(ru); d$
'---------------------------- nochmal ,aufhren -----------------------------
LOCATE 20: INPUT "Mchten Sie nochmal (j/n)"; bla$
SELECT CASE bla$
CASE IS = "n": GOTO daswars
CASE ELSE: GOTO nochmal
END SELECT
daswars:
COLOR 14, 0
CLS : CALL awdh(8, 2)
END

'zeigt die "Abschiedskarte"
SUB awdh (zeile%, spalte%)
LOCATE zeile%, spalte%   '8, 2 ist die Mitteneinstellung
PRINT "                                              ////                "
LOCATE zeile% + 1, spalte%
PRINT "                                             (o o)                "
LOCATE zeile% + 2, spalte%
PRINT "        oOO(_)OOoͻ "
LOCATE zeile% + 3, spalte%
PRINT "                                                                "
LOCATE zeile% + 4, spalte%
PRINT "                                                                "
LOCATE zeile% + 5, spalte%
PRINT "                                                                "
LOCATE zeile% + 6, spalte%
PRINT "        ͼ "
COLOR 7, 0: PRINT
END SUB

'zeigt das Schaltbild der Kollektorschaltung
SUB bildko (p%)
LOCATE p%
PRINT "                                       "                 '1
PRINT "                                     U+="                '2
PRINT "         fu= 50 Hz   o  Pv="              '3
PRINT "                      Ro           Ic="                '4
PRINT "                                   Ro="                '5
PRINT "                 Ce         C      Ru="                '6
PRINT "               oĴB   npn-Si-Transistor"      '7
PRINT "       Eingang              E   min.="                '8
PRINT "               o             o  Re="              '9
PRINT "                     Ru      Re  o                "   '10
PRINT "                                                 "   '11
      '123456789-123456789-123456789-123456789-123456789-123456789
      '    0         1         2         3         4         5
PRINT
END SUB

'wandelt die Werte in die E12-Normreihe um
FUNCTION e12 (a)
f = 1
IF a = 0 THEN GOTO pengk2      'zwei Schleifen tragen dafr Sorge, da
IF a < .8 THEN GOTO zukl2      'auch sehr kleine und sehr groe Zahlen
weiter2:                       'bercksichtigt werden.
IF a < 8 THEN GOTO ok2
f = f * 10
a = a / 10                     'in der "echten" E12-Reihe kommt es zu
GOTO weiter2                   'Doppelangaben, die in dieser Liste be-
ok2:                                           'seitigt wurden.
IF a >= .9 AND a < 1.1 THEN e12 = 1 * f
IF a >= 1.1 AND a < 1.32 THEN e12 = 1.2 * f
IF a >= 1.32 AND a < 1.65 THEN e12 = 1.5 * f
IF a >= 1.65 AND a < 1.98 THEN e12 = 1.8 * f
IF a >= 1.98 AND a < 2.42 THEN e12 = 2.2 * f
IF a >= 2.42 AND a < 2.97 THEN e12 = 2.7 * f
IF a >= 2.97 AND a < 3.63 THEN e12 = 3.3 * f
IF a >= 3.63 AND a < 4.29 THEN e12 = 3.9 * f
IF a >= 4.29 AND a < 5.17 THEN e12 = 4.7 * f
IF a >= 5.17 AND a < 6.16 THEN e12 = 5.6 * f
IF a >= 6.16 AND a < 7.48 THEN e12 = 6.8 * f
IF a >= 7.48 AND a < 9 THEN e12 = 8.2 * f
GOTO pengk2
zukl2:
IF a >= .8 THEN GOTO ok2
f = f / 10
a = a * 10
GOTO zukl2
pengk2:
END FUNCTION

'wandelt den Wert nach der E6-Normenreihe um
FUNCTION e6 (b)
f = 1
IF b = 0 THEN GOTO pengk             'diese FUNCTION beruht auf dem selben
IF b < .8 THEN GOTO zukl             'selben Prinzip wie E12.
weiter:
IF b < 8 THEN GOTO ok
f = f * 10
a = b / 10
GOTO weiter
ok:
IF b >= .8 AND b < 1.2 THEN e6 = 1 * f
IF b >= 1.2 AND b < 1.8 THEN e6 = 1.5 * f
IF b >= 1.8 AND b < 2.64 THEN e6 = 2.2 * f
IF b >= 2.64 AND b < 3.96 THEN e6 = 3.3 * f
IF b >= 3.96 AND b < 5.64 THEN e6 = 4.7 * f
IF ab >= 5.64 AND b < 8 THEN e6 = 6.8 * f
GOTO pengk
zukl:
IF b >= .8 THEN GOTO ok
f = f / 10
b = b * 10
GOTO zukl
pengk:
END FUNCTION

'ermglicht Eingaben mit oberer und unterer Grenzwert-Kontrolle.
'nach der richtigen Eingabe blitzt es, um die nchste Frage anzukndigen.
'Die Maske wird durch Eingeben von Buchstaben nicht zerstrt.
'ow=oberer Grenzwert, uw=unterer Grenzwert, a=Platzhalter fr Wert, der
'eingeben wird, z=Positi. des Fragenblocks, f$="Frage mit Fragezeichen"
SUB Frage (ow, uw, a, z, f$)
ks$ = "!!! ZU KLEIN !!!     "
g$ = "!!! ZU GROSS !!!     "
b$ = "!!! DAS IST KEINE ZAHL !!!          "
DO
pppp:
LOCATE z + 1
PRINT "                                                                     "
LOCATE z + 1
COLOR 3, 0
PRINT "(Geben Sie einen Wert zwischen"; uw; "und"; ow; "ein!) "
COLOR 7, 0
LOCATE z
PRINT "                                                                     "
LOCATE z
PRINT f$
LOCATE z, LEN(f$) + 2
INPUT "", a$
'Nun wird festgestellt, ob versehentlich ein Buchstabe eingetippt wurde.
IF VAL(a$) <> 0 OR a$ = "0" THEN
   a = VAL(a$): GOTO aaaaa
ELSE
COLOR 4, 0
               LOCATE z, LEN(f$) + 2: PRINT b$: BEEP: BEEP: BEEP: BEEP
COLOR 7, 0
END IF
GOTO pppp
aaaaa:
COLOR 4, 0
IF a < uw THEN LOCATE z, LEN(f$) + 2: PRINT ks$: BEEP: BEEP: BEEP
IF a > ow THEN LOCATE z, LEN(f$) + 2: PRINT g$: BEEP: BEEP: BEEP
COLOR 7, 0
LOOP UNTIL a >= uw AND a <= ow
SOUND 50, 1: SOUND 100, 1: SOUND 200, 1
'sorgt dafr das die Frage mit eingegebener Zahl nach Blitz sichtbar bleibt
LOCATE z + 1
PRINT ""
LOCATE z + 1
COLOR 3, 0
PRINT "(Geben Sie einen Wert zwischen"; uw; "und"; ow; "ein!)     "
COLOR 7, 0
LOCATE z
PRINT ""
LOCATE z
PRINT f$ + " " + a$ + "                               "
END SUB

'rundet auf 2 Stellen hinter dem Komma
FUNCTION k (wert)
faktor% = 10 ^ 2
rrrrrr = wert * faktor% + .5
rrrrrr = INT(rrrrrr)
rrrrrr = rrrrrr / faktor%
'IF wert < 1 THEN k = wert
'IF wert >= 1 THEN k = rrrrrr
k = rrrrrr
END FUNCTION

'setzt einen Text in die Zeilenmitte
SUB mitte (zeil%, text$)
LOCATE zeil%, 40 - LEN(text$) / 2
PRINT text$
END SUB

