REM              Nachfolgend ein kleines Q-Basic Programm zur
REM
REM              BERECHNUNG EINES   S C H M I T T - T R I G G E R S
REM
bu:
schlau$ = "a"
CLS : PRINT "     BERECHNUNG EINES SCHMITT-TRIGGERS MIT ZWEI TRANSISTOREN"
REM
PRINT
PRINT "                                             U+   "
PRINT "                  +    "
PRINT "                   R1                 R2        "
PRINT "                                     o    "
PRINT "                                    C       Aus "
PRINT "                  B  T2        "
PRINT "                 C       R3         E      o    "
PRINT "      oB   T1                         "
PRINT "   Ein    R4     E                             "
PRINT "                            Schmitt-Trigger mit"
PRINT "      o            R5                           zwei Transistoren"
PRINT "                       npn-Transistoren        "
PRINT "                                               "
PRINT
PRINT " 45 V > U+ > Schwellwert EIN > 1 V > Schwellwert AUS > 0.9 V"
PRINT "  (Das Programm achtet auf die Einhaltung der Grenzwerte)": PRINT
neu:
PRINT "Wie hoch ist die Speisespannung in Volt (Die Spannung mu sich"
INPUT "zwischen 2 und 45 Volt bewegen)"; v
IF v > 45 THEN PRINT "Die Spannung mu kleiner als 45 Volt sein!": GOTO neu
IF v < 2 THEN PRINT "Die Spannung mu mindestens 2 Volt betragen!": GOTO neu
PRINT
hyst:
PRINT "Wie hoch ist der Schwellwert EIN in Volt (Die Spannung mu kleiner"
INPUT "als die Speisespannung sein und mindestens 1 Volt haben)"; e
IF e < 1 THEN PRINT " Die Mindestspannung mu 1 Volt sein!": GOTO hyst
IF v <= e THEN PRINT "Der Wert EIN mu kleiner als"; v; "V sein!": GOTO hyst
PRINT
knall:
PRINT "Wie hoch ist der Schwellwert AUS in Volt (Die Spannung mu kleiner"
INPUT "als EIN sein und mindestens 0.9 Volt haben)"; a
IF a < .9 THEN PRINT "Die Mindestspannung mu 0.9 Volt sein": GOTO knall
IF e <= a THEN PRINT "Der Wert AUS mu kleiner als"; e; "V sein!": GOTO knall
PRINT : PRINT "                          ZUSAMMENFASSUNG": PRINT
PRINT "Speisespannung  in Volt:"; v: PRINT ; "Schwellwert EIN in Volt:"; e
PRINT "Schwellwert AUS in Volt:"; a
PRINT : INPUT "Mchten Sie andere Werte eingeben? (j/n)"; a$
IF a$ = "j" THEN GOTO neu
h = e - a
ramsch:
PRINT : INPUT "Wie hoch ist die maximale Eingangsspannung in Volt"; ue
IF ue <= e THEN PRINT "Die max. Eingangssp. mu grer als"; e; "Volt sein!"
IF ue <= e THEN GOTO ramsch
GOTO knaller
boller:
PRINT : PRINT "Mchten Sie zurck zum Programmanfang (j) o. aufhren (n)"
INPUT "oder das Schaltbild mit den Berechnungen sehen (s)"; c$
IF c$ = "j" THEN GOTO bu
IF c$ = "s" THEN GOTO jubeltrubel
END
knaller:
PRINT : INPUT "Wie gro soll der Wert des Kollektorstroms in mA sein"; c2
IF c2 < .6 THEN PRINT "Strme unter 0.6 mA sind zu klein!": GOTO knaller
IF c2 > 10 THEN PRINT "Strme ber 10 mA sind zu hoch!": GOTO knaller
faller:
zv = 2.5
re = 50000
du = 0
CLS : PRINT "                      B I T T E   W A R T E N  ": PRINT
PRINT "Es dauert nicht lange und es bimmelt wenn die Berechnung fertig ist."
fertig:
du = du + 1
re = re - (.01 * re) - 1
r2 = ((v - .2) / (e - .7) - 1) * re
ic2 = (v - .2) / (r2 + re)
LOCATE 4, 3
PRINT re, r2, ic2, du
IF ic2 <= c2 * .001 THEN GOTO fertig
r1 = ((v - .2) / (a - .7) - 1) * re
ic1 = (v - .2) / (re + r1)
CLS : PRINT "Der gemeinsame Emitterwiderstand hat"; re; "Ohm."
PRINT : PRINT "Der Kollektorwiderstand des 2. Transistors hat"; r2; "Ohm."
PRINT "Der Kollektorstrom des 2. Transistors hat"; ic2; "A."
PRINT "Die Verlustleistung des 2. Transistors ist"; ic2 * .2; "Watt."
PRINT : PRINT "Der Kollektorwiderstand des 1. Transistors hat"; r1; "Ohm."
PRINT "Der Kollektorstrom des 1. Transistors hat"; ic1; "A."
IF schlau$ = "k" AND ic1 < .0005 THEN c2 = c2 * 1.2: GOTO faller
IF ic1 < .0005 THEN PRINT : PRINT "DER KOLLEKTORSTROM VON T1 IST ZU KLEIN!"
IF ic1 < .0005 THEN BEEP: BEEP: BEEP: PRINT : GOTO abcd
risiko:
PRINT "Die Verlustleistung des 1. Transistors ist"; ic1 * .2; "Watt."
PRINT : PRINT "Speisespannung in Volt:"; v
PRINT "Schwellwert EIN in Volt    :"; e
PRINT "Schwellwert AUS in Volt    :"; a
h = e - a
PRINT "Die Schalthysterese betrgt"; h; "Volt.": PRINT
x = 37
brodelr2:
x = x + (x * .1)
SOUND x, 1
IF x <= 3000 THEN GOTO brodelr2
rb1 = (ue - .7 - re * ic2) / (zv * ic1)
rb2 = (v - .7 - re * ic1) / (zv * ic2)
PRINT : PRINT "Der Basiswiderstand des 1. Transistors hat"; rb1; "Ohm."
PRINT "Der Basiswiderstand des 2. Transistors hat"; rb2; "Ohm."
ure = re * ic2
ul = ure + .2
PRINT "Der HIGH-Pegel am Ausgang betrgt"; v; "Volt."
PRINT "Der LOW -Pegel am Ausgang betrgt"; ul; "Volt."
GOTO boller
jubeltrubel:
CLS : PRINT "            S  C  H  M  I  T  T  -  T  R  I  G  G  E  R": PRINT
PRINT "                                               U+ ="; v; "Volt"
PRINT "                +   R1 ="; r1 / 1000; "k"
PRINT "                 R1                 R2       R2 ="; r2 / 1000; "k"
PRINT "                                   o    "
PRINT "                                  C       Aus  HIGH ="; v; "Volt"
PRINT "                B  T2          LOW ="; ul; "Volt"
PRINT "               C       R3         E      o    "
PRINT "    oB   T1                         "
PRINT " Ein    R4     E                            R3 ="; rb2 / 1000; "k"
PRINT "                         R4 ="; rb1 / 1000; "k"
PRINT "    o            R5                           "
PRINT "                     npn-Transistoren       R5 ="; re; ""
PRINT "                                             "
PRINT " Maximale Eingangsspannung ="; ue; "Volt"
PRINT " Schwellwert EIN ="; e; "Volt   Schwellwert AUS ="; a; "Volt"
PRINT " IcT1 ="; ic1 * 1000; "mA    IcT2 ="; ic2 * 1000; "mA": PRINT
IF ic1 < .0005 THEN PRINT "DER KOLLEKTORSTROM VON T2 KANN ZU KLEIN SEIN!"
PRINT
GOTO bbb
abcd:
PRINT "Mchten Sie den Kollektorstrom von T2 von Hand erhhen (j)"
PRINT "oder schrittweise erhhen lassen bis Ic von T1 mind. 0.5 mA hat (k)"
INPUT "oder mchten Sie den Wert so belassen wie er ist (l)"; schlau$
IF schlau$ = "j" THEN GOTO knaller
IF schlau$ = "k" THEN c2 = c2 * 1.2: GOTO faller
IF schlau$ = "l" THEN GOTO risiko
GOTO abcd:
bbb:
INPUT "Mchten Sie zurck zum Programmanfang (j) o. aufhren (n)"; pzz$
IF pzz$ = "j" THEN GOTO bu
END
REM ***END

