'berechnet eine Emitterschaltung mit Stromgegenkopplung fr
'die Arbeitspunktsabilisierung
DECLARE SUB bild (p%)                 'zeigt das Schaltbild
DECLARE SUB bilde (ze%, le%)          'zeigt das Schaltbild
DECLARE SUB frage (ow, uw, a, z, f$)  'Eingabeprozedur mit Grenzwertkontrolle
DECLARE SUB awdh (zeile%, spalte%)    'zeigt die Adresse fr Verabschiedung
DECLARE SUB mitte (zeil%, text$)      'setzt den Text in die Mitte der Zeile
DECLARE SUB rahmen (a)                'bildet einen Rahmen um die Zeile a
DECLARE SUB hem (h11, h12e4, h21, h22ms, rgg, rll)  'h-Parameter-Berechnung
DECLARE FUNCTION e6! (a!)             'wandelt Werte in die E 6-Reihe um
DECLARE FUNCTION k (wert)             'rundet auf 2 Stellen hinter dem Komma
DECLARE FUNCTION e12! (a!)            'wandelt Werte in die E 12-Reihe um
DIM SHARED z1, z2, vi, vu, vp, st, vpmax, rll, rgg, h11, h12e24, h21, h22ms
DIM SHARED ze%, le%
nochmal:
'------------------------ EINGABE ------------------------------------------
CLS : mitte 1, "BERECHNUNG EINER EMITTERSCHALTUNG"
CALL bild(3)
'------------------------- mit oder ohne h-Parameter? -----------------------
FOR weg% = 16 TO 20: LOCATE weg%: PRINT SPACE$(80): NEXT weg%
rahmen 19
LOCATE 18
INPUT "     Sind Ihnen die h-Parameter des Transistors bekannt (j/n)"; ent$
SELECT CASE ent$
CASE IS = "j": GOTO schwer: CASE IS = "h": GOTO schwer 'Ber. mit h-Parameter
CASE IS = "n": GOTO leicht     'Berechnung ohne h-Parameter
CASE ELSE: GOTO leicht
END SELECT: FOR weg% = 16 TO 20: LOCATE weg%: PRINT SPACE$(80): NEXT weg%
'--------------------------- Berechnung ohne h-Parameter -------------------
leicht:
FOR weg% = 14 TO 20: LOCATE weg%: PRINT SPACE$(80): NEXT weg%
COLOR 23, 0: LOCATE 3, 42: PRINT "?"
COLOR 7, 0: LOCATE 3: PRINT "    untere Grenzfre-                 U+="
mitte 14, "Folgende Berechnung bentigt nur Speisespannung,  min. und Ic."
CALL frage(45, 2, ub, 16, "Wie hoch ist die Speisespannung in Volt?")
LOCATE 3: PRINT "    untere Grenzfre-                 U+="; ub; "Volt"
COLOR 23, 0: LOCATE 4, 45: PRINT "?"
COLOR 7, 0
CALL frage(10, .005, ic, 17, "Wie hoch ist der Kollektorruhestrom in mA?")
LOCATE 4: PRINT "    quenz= 50 Hz     o  Ic="; ic; "mA"
COLOR 23, 0: LOCATE 10, 50: PRINT "?"
COLOR 7, 0
CALL frage(500, 70, b, 18, "Wie hoch ist Beta min. des Transistors?")
LOCATE 10: PRINT "               o         ڴĴ      Beta min="; b
LOCATE 17: PRINT "                                                         "
LOCATE 19: PRINT "                                                         "
IF bb = 1 THEN GOTO nn1
IF bb = 5 THEN GOTO nn12
nn:
'------------------------ BERECHNUNGEN -------------------------------------
s = 36.5 * ic         'Steilheit des Transistors nach Faustformel (mA/V)
re = (.7 / ic) * 1000 'Emitterwiderstandand in Ohm
ur = (ub - 1) / 2     'Spannung, die am Lastwiderstand Rc abfllt (Volt)
                      'ur = auch maximale Ausgangsspitzenspannung in Vs
a = ur + 1            'Spannung des Arbeitspunkts am Koll. gegen Masse (Volt)
iq = (ic / b) * 10    'Querstrom durch den Basisspannungsteiler in mA
rc = (ur / ic) * 1000 'Lastwiderstand Rc u. Ausgangswiderstand in Ohm
ro = (ub - 1.4) * 1000 / (iq * 1.1) 'oberer Basiswiderstand Ro in Ohm
ru = (1.4) * 1000 / iq              'unterer Basiswiderstand Ru in Ohm
v = 36.5 * ur                       'Spannungsverstrkung der Schaltung
pv = ic * a * .001                  'Transistorverlustleistung in Watt
ce = (s / 200) * 1000               'Emitterkondensator in F bei 50 Hz fmin
ree = (b / s) * 1000                'Transistoreingangswiderstand in Ohm
rp = (ro * ru) / (ro + ru)          'Die beiden Basiswiderstnde parallel
rg = (ree * rp) / (ree + rp)        'ree//ro//ru = Gesamteingangswid. in Ohm
ck = 1000 / (200 * (rg / 1000))     'Eingangskoppelkondensator in F
vo = ur / .7                        'Spannungsverstrkung ohne Emit.-Kondens.
LOCATE 5
PRINT "                      Ro       Rc     Verst.faktor="; k(v)
PRINT "                              o  max. Ausg.Sp.="; k(ur); "Vs"
IF bb% = 1 THEN GOTO nn1
IF bb% = 5 THEN GOTO nn12
'--------------------------- Endergebnis (gerundet) ------------------------
gerundet:
tt = 40   'Tabulatorabstand
ll = 16   'Zeilenanfang des Ergebnisblocks
LOCATE ll - 2: PRINT SPACE$(80)
mitte 14, "Das auf zwei Stellen hinter dem Komma gerundete Rechenergebnis:"
LOCATE ll
PRINT "Ro hat"; k(ro / 1000); "k"; TAB(tt); "Ru hat"; k(ru / 1000); "k   "
LOCATE ll + 1
PRINT "Rc hat"; k(rc / 1000); "k"; TAB(tt); "Re hat"; k(re / 1000); "k   "
LOCATE ll + 2
PRINT "Ck hat"; k(ck); "F"; TAB(tt); "Ce hat"; k(ce); "F             "
LOCATE ll + 3
PRINT "Der Eingangswid. hat"; k(rg / 1000); "k"
LOCATE ll + 3, tt
PRINT "Der Ausgangswid. hat"; k(rc / 1000); "k"

'---------------------------- beenden, weitermachen, e12, e6, ---------------
prima:
LOCATE 22: PRINT SPACE$(80): LOCATE 23: PRINT SPACE$(80)
LOCATE 21: PRINT "Mchten Sie die Bauteilewerte nach der E6-Reihe sehen (1)"
LOCATE 22
PRINT "oder das Rechenergebnis (2) oder beenden (3) oder nochmal (4)"
falschgetippt:
LOCATE 23: PRINT SPACE$(80)
LOCATE 23: INPUT "oder die Werte nach der E12-Reihe haben (5)"; bb%
SELECT CASE bb%
CASE IS = 1: GOTO nn
CASE IS = 5: GOTO nn
CASE IS = 2: GOTO nn
CASE IS = 3: GOTO ende
CASE IS = 4: GOTO nochmal
CASE ELSE: GOTO falschgetippt
END SELECT
'--------------------------- Bauteilewerte nach E6-Reihe anzeigen ----------
nn1:
FOR grr% = 0 TO 2
LOCATE ll + grr%: PRINT SPACE$(80)
NEXT
LOCATE ll - 2: PRINT SPACE$(80)
mitte ll - 2, "BAUELEMENTE-WERTE NACH DER E6-REIHE"
LOCATE ll
PRINT "Ro hat"; e6(ro / 1000); "k"; TAB(tt); "Ru hat"; e6(ru / 1000); "k  "
LOCATE ll + 1
PRINT "Rc hat"; e6(rc / 1000); "k"; TAB(tt); "Re hat"; e6(re / 1000); "k  "
LOCATE ll + 2
PRINT "Ck hat"; e6(ck); "F"; TAB(tt); "Ce hat"; e6(ce); "F"
GOTO prima
'--------------------------- Bauteilewerte nach E12-Reihe anzeigen ---------
nn12:
FOR grr% = 0 TO 2: LOCATE ll + grr%: PRINT SPACE$(80): NEXT
LOCATE ll - 2: PRINT SPACE$(80): LOCATE ll - 2
mitte ll - 2, "BAUELEMENTE-WERTE NACH DER E12-REIHE": LOCATE ll
PRINT "Ro hat"; e12(ro / 1000); "k"; TAB(tt); "Ru hat"; e12(ru * .001); "k "
LOCATE ll + 1
PRINT "Rc hat"; e12(rc / 1000); "k"; TAB(tt); "Re hat"; e12(re / 1000); "k "
LOCATE ll + 2
PRINT "Ck hat"; e12(ck); "F     "; TAB(tt); "Ce hat"; e12(ce); "F      "
GOTO prima
'----------------------------------------------------------------------------
ende:
CLS : awdh 8, 2
END
'------------------------------Berechnung mit h-parametern ------------------
schwer:
FOR weg% = 16 TO 20: LOCATE weg%: PRINT SPACE$(80): NEXT weg%: LOCATE 16
PRINT "Wie gro ist..."
INPUT "...  der Kurzschlueingangswiderstand (h11) in k? ", h11
INPUT ".... die Leerlaufspannungsrckwirkung (h12) * E-4? ", h12e4
INPUT "...... die Kurzschlustromverstrkung (h21)?       ", h21
INPUT "........ der Leerlaufausgangsleitwert (h22) in S? ", h22ms
PRINT : PRINT "Wie gro ist..."
INPUT "........... der Kollektorstrom in mA?   ", ic
INPUT ". der Generatorinnenwiderstand in k?   ", rgg
INPUT "........... die Speisespannung in Volt? ", ub
'------------------------------- Berechnung --------------------------------
re = (.7 / ic) * 1000 'Emitterwiderstand in Ohm
ur = (ub - 1) / 2     'Spannung, die am Lastwiderstand Rc abfllt (Volt)
                      'ur = auch maximale Ausgangsspitzenspannung in Vs
a = ur + 1            'Spannung des Arbeitspunkts am Koll. gegen Masse (Volt)
rll = (ur / ic)       'Lastwiderstand Rc in kOhm
CALL hem(h11, h12e4, h21, h22ms, rgg, rll)  'h-Parameter werden aufgerufen
b = h21               'Kurzschlustromverstrkungsfaktor gleich Beta
iq = (ic / b) * 10    'Querstrom durch den Basisspannungsteiler in mA
ro = (ub - 1.4) * 1000 / (iq * 1.1)        'oberer Basiswiderstand Ro in Ohm
ru = (1.4) * 1000 / iq              'unterer Basiswiderstand Ru in Ohm
pv = ic * a * .001                  'Transistorverlustleistung in Watt
ce = (st / 200) * 1000              'Emitterkondensator in F bei 50 Hz fmin
ree = (z1) * 1000                   'Transistoreingangswiderstand in Ohm
rp = (ro * ru) / (ro + ru)          'Die beiden Basiswiderstnde parallel
rg = (ree * rp) / (ree + rp)        'ree//ro//ru = Gesamteingangswid. in Ohm
ck = 1000 / (200 * (rg / 1000))     'Eingangskoppelkondensator in F
vo = ur / .7                        'Spannungsverstrkung ohne Emit.-Kondens.
raus = (rll * z2) / (rll + z2)      'Ausgangswiderstand in kOhm
'-------------------------------- Ausgabe -----------------------------------
PRINT : PRINT "Koppelkondensator Ck in uF  "; k(ck)
PRINT "Emitterkondensator in uF    "; k(ce)
PRINT "Ro in k                    "; k(ro / 1000)
PRINT "Ru in k                    "; k(ru / 1000)
PRINT "Gesamteingangswid. in k    "; k(rg / 1000)
PRINT "Gesamtausgangswid. in k    "; k(raus)
PRINT "Emitterwiderstand in k     "; k(re / 1000)
PRINT "Kollektorwiderstand in k   "; k(rll)
PRINT "Transistoreingangswid. in k"; k(z1)
PRINT "Transistorausgangswid. in k"; k(z2)
PRINT "Spannungsverstrkung        "; k(-vu)
CALL bilde(12, 46)
LOCATE 25: INPUT "Mchten Sie nochmal (1) oder Programm beenden (2)"; also%
SELECT CASE also%: CASE IS = 1: GOTO nochmal
CASE IS = 2: GOTO ende: CASE ELSE: GOTO nochmal
END SELECT
END

'zeigt die "Abschiedskarte"
SUB awdh (zeile%, spalte%)
LOCATE zeile%, spalte%   '8, 2 ist die Mitteneinstellung
PRINT "                                              ////                "
LOCATE zeile% + 1, spalte%
PRINT "                                             (o o)                "
LOCATE zeile% + 2, spalte%
PRINT "        oOO(_)OOoͻ "
LOCATE zeile% + 3, spalte%
PRINT "                                                                "
LOCATE zeile% + 4, spalte%
PRINT "                                                                "
LOCATE zeile% + 5, spalte%
PRINT "                                                                "
LOCATE zeile% + 6, spalte%
PRINT "        ͼ "
SYSTEM
END SUB

'zeigt das Schaltbild, vorbereitet fr das Einsetzen von Zahlen.
SUB bild (p%)
LOCATE p%
PRINT "    untere Grenzfre-                 U+="
PRINT "    quenz= 50 Hz     o  Ic=                      "
PRINT "                      Ro       Rc     "
PRINT "                              o  "
PRINT "                Ck           C       Aus "
PRINT "               oĴB      o  "
PRINT "            Ein          Ce  E      npn-Silizium-Transistor"
PRINT "               o         ڴĴ      Beta min=                 "
PRINT "                     Ru      Re   (minimaler Stromverstrkungs- "
PRINT "                                  faktor)"
END SUB

'ermglicht die Positionierung des Schaltbildes an einen beliebigen Punkt
'des Monitorschirms. ze fr Zeile, le fr Spalte
SUB bilde (ze%, le%)
LOCATE ze%, le%:     PRINT " untere Grenzfre-             U+ "
LOCATE ze% + 1, le%: PRINT " quenz= 50 Hz  o "
LOCATE ze% + 2, le%: PRINT "                Ro       Rc    "
LOCATE ze% + 3, le%: PRINT "                        o "
LOCATE ze% + 4, le%: PRINT "          Ck           C   Aus "
LOCATE ze% + 5, le%: PRINT "         oĴB      o "
LOCATE ze% + 6, le%: PRINT "      Ein          Ce  E      "
LOCATE ze% + 7, le%: PRINT "         o         ڴĴ      "
LOCATE ze% + 8, le%: PRINT "               Ru      Re   "
LOCATE ze% + 9, le%: PRINT "                            "
END SUB

'wandelt die Werte in die E12-Normreihe um
FUNCTION e12 (a)
f = 1
IF a = 0 THEN GOTO pengk2      'zwei Schleifen tragen dafr Sorge, da
IF a < .8 THEN GOTO zukl2      'auch sehr kleine und sehr groe Zahlen
weiter2:                       'bercksichtigt werden.
IF a < 8 THEN GOTO ok2
f = f * 10
a = a / 10                     'in der "echten" E12-Reihe kommt es zu
GOTO weiter2                   'Doppelangaben, die in dieser Liste be-
ok2:                                           'seitigt wurden.
IF a >= .9 AND a < 1.1 THEN e12 = 1 * f
IF a >= 1.1 AND a < 1.32 THEN e12 = 1.2 * f
IF a >= 1.32 AND a < 1.65 THEN e12 = 1.5 * f
IF a >= 1.65 AND a < 1.98 THEN e12 = 1.8 * f
IF a >= 1.98 AND a < 2.42 THEN e12 = 2.2 * f
IF a >= 2.42 AND a < 2.97 THEN e12 = 2.7 * f
IF a >= 2.97 AND a < 3.63 THEN e12 = 3.3 * f
IF a >= 3.63 AND a < 4.29 THEN e12 = 3.9 * f
IF a >= 4.29 AND a < 5.17 THEN e12 = 4.7 * f
IF a >= 5.17 AND a < 6.16 THEN e12 = 5.6 * f
IF a >= 6.16 AND a < 7.48 THEN e12 = 6.8 * f
IF a >= 7.48 AND a < 9 THEN e12 = 8.2 * f
GOTO pengk2
zukl2:
IF a >= .8 THEN GOTO ok2
f = f / 10
a = a * 10
GOTO zukl2
pengk2:
END FUNCTION

'wandelt den Wert nach der E6-Normenreihe um
FUNCTION e6 (a)
f = 1
IF a = 0 THEN GOTO pengk             'diese FUNCTION beruht auf dem selben
IF a < .8 THEN GOTO zukl             'selben Prinzip wie E12.
weiter:
IF a < 8 THEN GOTO ok
f = f * 10
a = a / 10
GOTO weiter
ok:
IF a >= .8 AND a < 1.2 THEN e6 = 1 * f
IF a >= 1.2 AND a < 1.8 THEN e6 = 1.5 * f
IF a >= 1.8 AND a < 2.64 THEN e6 = 2.2 * f
IF a >= 2.64 AND a < 3.96 THEN e6 = 3.3 * f
IF a >= 3.96 AND a < 5.64 THEN e6 = 4.7 * f
IF a >= 5.64 AND a < 8 THEN e6 = 6.8 * f
GOTO pengk
zukl:
IF a >= .8 THEN GOTO ok
f = f / 10
a = a * 10
GOTO zukl
pengk:
END FUNCTION

'ermglicht Eingaben mit oberer und unterer Grenzwert-Kontrolle.
'nach der richtigen Eingabe blitzt es, um die nchste Frage anzukndigen.
'Die Maske wird durch Eingeben von Buchstaben nicht zerstrt.
'ow=oberer Grenzwert, uw=unterer Grenzwert, a=Platzhalter fr Wert, der
'eingeben wird, z=Positi. des Fragenblocks, f$="Frage mit Fragezeichen"
SUB frage (ow, uw, a, z, f$)
ks$ = "!!! ZU KLEIN !!!     "
g$ = "!!! ZU GROSS !!!     "
b$ = "!!! DAS IST KEINE ZAHL !!!          "
DO
pppp:
LOCATE z + 1
PRINT "                                                                     "
LOCATE z + 1
PRINT "(Geben Sie einen Wert zwischen"; uw; "und"; ow; "ein!) "
LOCATE z
PRINT "                                                                     "
LOCATE z
PRINT f$
LOCATE z, LEN(f$) + 2
INPUT "", a$
'Nun wird festgestellt, ob versehentlich ein Buchstabe eingetippt wurde.
IF VAL(a$) <> 0 OR a$ = "0" THEN
   a = VAL(a$): GOTO aaaaa
ELSE
               LOCATE z, LEN(f$) + 2: PRINT b$: BEEP: BEEP: BEEP: BEEP
END IF
GOTO pppp
aaaaa:
IF a < uw THEN LOCATE z, LEN(f$) + 2: PRINT ks$: BEEP: BEEP: BEEP
IF a > ow THEN LOCATE z, LEN(f$) + 2: PRINT g$: BEEP: BEEP: BEEP
LOOP UNTIL a >= uw AND a <= ow
SOUND 50, 1: SOUND 100, 1: SOUND 200, 1
'sorgt dafr das die Frage mit eingegebener Zahl nach Blitz sichtbar bleibt
LOCATE z + 1
PRINT ""
LOCATE z + 1
PRINT "(Geben Sie einen Wert zwischen"; uw; "und"; ow; "ein!)     "
LOCATE z
PRINT ""
LOCATE z
PRINT f$ + " " + a$ + "                               "
END SUB

'unternimmt Berechnungen, die mit h-Parametern mglich sind
SUB hem (h11, h12e4, h21, h22ms, rgg, rll)    'Berechnungen mit h-Parametern
'unbedingt alle Ausgabe-Parameter mit DIM SHARED deklarieren
'h11 = Kurzschlueingangswiderstand in kOhm (u1/i1)
'h12e4 = Leerlaufspannungsrckwirkung * E-4 (u1/u2)
'h21 = Kurzschlustromverstrkunsgsfaktor ( oder Beta)
'h22ms = Leerlaufausgangsleitwert (i1/u2) in mikroSiemens
'rgg= Generatorinnenwiderstand in kOhm
'rll = Ausgangslastwiderstand in kOhm
h22 = h22ms / 1000                              'Generatorinnenwid. in k
h12 = h12e4 / 10000!                            'Spannungsrckwirkung
dh = (h11 * h22) - (h12 * h21)                  'Determinante
z1 = (h11 + dh * rll) / (1 + (h22 * rll))       'Eingangswiderstand in kOhm
z2 = (h11 + rgg) / (dh + h22 * rgg)             'Ausgangswiderstand in kOhm
vi = h21 / (1 + h22 * rll)                      'Stromverstrkung     (i2/i1)
vu = (-h21 * rll) / (h11 + dh * rll)            'Spannungsverstrkung (u2/u1)
vp = (h21 ^ 2 * rll) / ((1 + h22 * rll) * (h11 + dh * rll))
         'bertragungsfaktor, falls alle Parameter reel: Leistungsverstrkung
st = h21 / h11                                  'Steilheit (y21) in mA/V
ladugaarden = 4 * h21 ^ 2 * rgg * rll      'Zwischenwert ohne Bedeutung
vpmax = ladugaarden / ((1 + h22 * rll) * rgg + h11 + dh * rll) ^ 2
                                'bertragungsfaktor bei Anpassung am Eingang
END SUB

'rundet auf 2 Stellen hinter dem Komma
FUNCTION k (wert)
faktor% = 10 ^ 2
rrrrrr = wert * faktor% + .5
rrrrrr = INT(rrrrrr)
rrrrrr = rrrrrr / faktor%
'IF wert < 1 THEN k = wert
'IF wert >= 1 THEN k = rrrrrr
k = rrrrrr
END FUNCTION

'setzt einen Text beliebiger Lnge in die Mitte der Zeile
SUB mitte (zeil%, text$)
LOCATE zeil%, 40 - LEN(text$) / 2
PRINT text$
END SUB

'umrahmt einen Text
SUB rahmen (a)
LOCATE a - 3
PRINT "ͻ"
PRINT "                                                                   "
PRINT "                                                                   "
PRINT "                                                                   "
PRINT "ͼ"
END SUB

