# Eingangskennlinie eines FET
set title "Eingangskennlinie eines FET Id(ugs)=ido*(1-(ugs/uo))**2"
set xlabel "Gatespannung Ug (Volt)"
set ylabel "Drainstrom Id (A)"
Id(ugs)=ido*(1-(ugs/uo))**2
# ido, drainstrom bei ugs=0, wird auch Idss genannt (Drain-Source-Kurzschlustrom)
ido=12e-3
# uo ist ugs, bei der kein drainstrom fliet (pinch off), wird auch pinch-off-Spannung genannt
uo = -3
set grid
set xrange [uo : 0]
set yrange [0 : ido]
set dummy ugs
set sample 100, 100
plot Id(ugs)
pause -1

# Anmerkung die Kurve der Abschnrgrenze kann man sich als die Saettignungskennlinie vorstellen,
# derren x-Werte um die pinch-off-Spannung nach rechts verschoben ist. Auf der sicheren Seite liegt man
# wenn Uds mind. up*-1 ist.