'----- schnipp ---------------- Alles oberhalb dieser Linie Loeschen --------
nochmal:
COLOR 14, 9
CLS
COLOR 12, 9
PRINT "          BERECHNUNG EINES EMITTERFOLGERS MIT DARLINGTON-TRANSISTOR  "
PRINT "            ------------------------------------------------------ "
COLOR 14, 9
INPUT "                    Wie hoch ist die Speisespannung (Volt)"; ubb
INPUT "         Wie hoch soll der Kollektorstrom von T2 (mA) sein"; ic2
INPUT "     Wie hoch ist der min. Stromverstaerkungsfaktor von T1"; b1
INPUT "     Wie hoch ist der min. Stromverstaerkungsfaktor von T2"; b2
             
  ube = .7      'Schwellenspannung (V)
  ucerest = .3  'Saettigungsspannung zwischen Kollektor und Emitter (V)
  ss = 40       'Transistorsteilheitsfaktor (mA/V)
                      
                      
      re = .5 * ubb / ic2   'Der Emitterwiderstand in kOhm
      rein = b1 * b2 / re   'differ. Eingangswiderstand ohne Basiswiderst.
      ic1 = ic2 / b2        'Kollektorstrom des 1. Transistors
      ib1 = ic1 / b1        'Basisstrom des 1. Transistors
      i1 = 10 * ib1         'Querstrom durch den Basisspannungsteiler
      ub1 = (2 * ube) + (.5 * ubb)    'Spannung an der Basis des 1. Transist.
      rbo = (ubb - ub1) / (i1 + ib1)  'oberer Basisspannungsteilerwiderstand
      rbu = ub1 / i1                  'unterer Basisspannungsteilerwiderstand
      rp = (rbo * rbu) / (rbo + rbu)  'Rbo//Rbu
      rg = (rp * rein) / (rp + rein)  'rein//Rbo//Rbu
      cein = 10000 / (2 * rg)         'Eingangskoppelkondensator in nF
      
      s = ss * (ic1 + ic2)            'Steilheit des Darlington in mA/V
      v = (s * re) / (1 + (s * re))   'Spannungsverstaerkung der Schaltung
      raus = ((rg / (b1 * b2)) + (1 / s)) * 1000  'Ausgangswiderstand in Ohm
      
      maus = .5 * ubb - 1.7        'max. Ausgangsspannung in Volt Spitze (Vs)
PRINT
COLOR 12, 9
PRINT " ********************************************************************"
COLOR 15, 9
PRINT
PRINT " Emitterwiderstand in kOhm....................................:"; re
PRINT " Kollektorstrom von T1 in mA..................................:"; ic1
PRINT " Basisstrom von von T1 in mA..................................:"; ib1
PRINT " Basisspannung von T1 (in Ruhe) in Volt.......................:"; ub1
PRINT " Der obere Widerstand Rbo des Basisspannungsteilers in kOhm...:"; rbo
PRINT " Der untere Widerstand Rbu des Basisspannungsteilers in kOhm..:"; rbu
PRINT " Die beiden Basisspannungsteilerwiderstaende parallel in kOhm.:"; rp
PRINT " Der differentielle Eingangswiderstand ohne Rbo//Rbu in kOhm..:"; rein
PRINT " Der diff. Eingangswiderstand mit Rbo//Rbu in kOhm............:"; rg
PRINT " Eingangskoppelkondensator in nF fuer fgu=30 Hz...............:"; cein
PRINT " Spannungsverstaerkung (dimensionslos)........................:"; v
PRINT " ungefhrer Ausgangswiderstand in Ohm.........................:"; raus
PRINT " maximale Ausgangsspannnung in Volt Spitze....................:"; maus
COLOR 12, 9
PRINT : INPUT "                   Mchten Sie nochmal (j/n)"; weiter$
IF weiter$ = "n" THEN GOTO beenden
GOTO nochmal
beenden:
SHELL "darlibil"
COLOR 7, 0
cls
SYSTEM
'------------------------ Alles unterhalb dieser Linie Loeschen -- schnipp --

