nochmal:
COLOR 0, 11
CLS : PRINT
PRINT " Berechnung eines Emitterfolgers (Kollektorschaltung)": PRINT
COLOR 1, 11
INPUT "        Wie hoch ist die Speisespannung in Volt"; ubb
INPUT "              Wie hoch ist min des Transistors"; beta
INPUT " Wie hoch soll der Kollektorstrom (mA) betragen"; ic
'Berechnung des Potentials am Emitter im Arbeitspunkt (ue)
ue = (ubb / 2) - .2           'Arbeitspunkt und maximale Ausgangspannung (Vs)
ie = ic + (ic / beta)         'Der Basisstrom wurde in den Emitterstrom
                              'eingerechnet.
re = ue / ie                  'Emitterwiderstand in k
ub = ue + .6                  'Spannung an der Basis
'Berechnung der Basisspannungsteilerwiderstnde (Querstrom 5*ib)
ib = ic / beta                'Basisstrom in mA
ro = (ubb - ub) / (6 * ib)    'Oberer Widerstand des Basisspannungsteilers
ru = ub / (5 * ib)            'Unterer Widerstand des Basisspannungsteilers
'------------------ Ausgabe der Widerstnde --------------------------------
COLOR 4, 11
PRINT
PRINT "                           Der Emitterwiderstand hat"; re; "k"
PRINT "        Der obere Basisspannungsteilerwiderstand hat"; ro; "k"
PRINT "       Der untere Basisspannungsteilerwiderstand hat"; ru; "k": PRINT
'------------------ Berechnung der Spannungsverstrkung ---------------------
rbe = 40 / (ib * 1000)         'Transistoreingangswiderstand in k
ua = ib * (1 + beta) * re
ue = ib * (rbe + (1 + beta) * re)
vu = ua / ue
PRINT " Die Spannungsverstrkung ist"; vu: PRINT
'------------------ Berechnung der Eingangs- und Ausgangswiderstnde --------
rbas = (ro * ru) / (ru + ro)   'Basisspannungsteilerwiderstnde parallel
'---- Ausgang unbelastet -------------
reinu = rbe + ((1 + beta) * re) 'Eingangswiderstand (k), Ausgang unbelastet
reinuges = (rbas * reinu) / (rbas + reinu)
COLOR 1, 11
PRINT " Der Eingangswiderstand bei unbelastetem Ausgang hat"; reinuges; "k"
'---- Ausgang belastet
              INPUT " Wie gro ist der Lastwiderstand in k"; rl
rges = (re * rl) / (re + rl)    're//rl
reinbe = rbe + ((1 + beta) * rges)
reinges = (rbas * reinbe) / (rbas + reinbe)
  PRINT " Der Eingangswiderstand bei belastetem Ausgang hat"; reinges; "k"
'-------------------------- Verabsschiedung ---------------------------------
    COLOR 1, 11: PRINT : INPUT "  Mchten Sie nochmal (j/n)"; weiter$
IF weiter$ = "n" THEN GOTO beenden
GOTO nochmal
beenden:
COLOR 7, 0
CLS
SYSTEM
'--------------------------------- Programmende -----------------------------

