nimmersatt:
CLS
PRINT "                 Schwingkreisberechnungsprogramm"
PRINT "====================================================================="
PRINT " Was mchten Sie berechnen?"
PRINT
PRINT "     1   Wickeldaten einer Spule"
PRINT
PRINT "     2   Berechnungen am Parallel- und Serienschwingkreis"
PRINT "         (im Anschlu daran knnen die Kreisverluste berechnet werden)"
PRINT
PRINT "     3   Programm endgltig beenden"
PRINT
INPUT " Geben Sie die entsprechende Nummer ein"; brumm
IF brumm = 1 THEN GOTO wickel
IF brumm = 2 THEN GOTO swing
IF brumm = 3 THEN GOTO schluss
GOTO nimmersatt
wickel:
REM ########################################################################
CLS
PRINT "             Konstruktion und Berechnung von Spulen"
PRINT "====================================================================="
PRINT
IF l = 0 THEN GOTO neu
PRINT "Mchten Sie den Induktivittswert verwenden, den Sie im Abschnitt 2"
INPUT "soeben berechnet hatten (j/n)"; swing1$
IF swing1$ = "j" THEN GOTO alt
IF swing1$ = "n" THEN GOTO neu
END
alt:
PRINT "Fr die Berechnungen wird der Wert"; l; "Henry verwendet."
GOTO drossel
neu:
INPUT "Geben Sie den Induktivittswert in Henry ein"; l
GOTO drossel
drossel:
REM ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
PRINT
PRINT "   1   Berechnung einer einlagigen Luftspule   "
PRINT "   2   Berechnug einer Spule mit Kern "
PRINT "   3   Zum Programmanfang"
PRINT
INPUT "Geben Sie die entsprechende Nummer ein"; fink
IF fink = 1 THEN GOTO luft
IF fink = 2 THEN GOTO kern
IF fink = 3 THEN GOTO nimmersatt
END
luft:
PRINT
PRINT "------------ E I N L A G I G E   L U F T S P U L E ------------------"
PRINT
INPUT "Geben Sie den Innendurchmesser (Spiralbohrer als Dorn) in mm an"; id
INPUT "Welchen Durchmesser in mm hat der Wickeldraht"; dwe
lr = l * 1000000!
dw = dwe / 10
d = id / 10
w = 0
GOTO mut
bohr:
d = d - .05
IF d <= 0 THEN PRINT "Spule kann nicht berechnet werden.": GOTO gemse
mut:
w = w + 1
IF w = 500 THEN PRINT "Es kann leider manchmal etwas lnger dauern."
la = w * dw
lx = (w * w * d * d) / ((100 * la) + (45 * d))
IF w > 10000 THEN GOTO meise
IF lx < lr THEN GOTO mut
IF la < .3 * d THEN GOTO bohr
SOUND 1000, 1: SOUND 1500, 1: SOUND 1000, 1: SOUND 1500, 1: SOUND 1000, 1
PRINT
PRINT "Die Spule hat einlagig und eng gewickelt"; w; "Windungen."
PRINT "Die Lnge betrgt"; la * 10; "mm."
IF id > (d * 10) THEN PRINT "Der Bohrer hat nun einen Durchmesser"
IF id > (d * 10) THEN PRINT "von"; d * 10; "mm."
PRINT
gemse:
INPUT "Mchten Sie zum Programmanfang (j/n)"; brodel$
IF brodel$ = "j" THEN GOTO nimmersatt
IF brodel$ = "n" THEN GOTO wickel
END
meise:
PRINT "Die Spule hat leider ber 10000 Windungen. Es ist anzunehmen, da "
PRINT "Sie weder Zeit noch Lust haben, diese Spule zu wickeln."
GOTO gemse
REM ------------------------- K E R N --------------------------------------
kern:
CLS
PRINT "             BERECHNUNG EINER SPULE MIT MASSEN-KERN"
PRINT
INPUT "Kennen Sie den AL-Wert der Spule (j/n)"; spinne$
IF spinne$ = "j" THEN GOTO weisalwert
IF spinne$ = "n" THEN GOTO weisnichtalwert
GOTO kern
REM ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
weisalwert:
INPUT "Wie gro ist der AL-Wert in H/w"; alwert
donnerblitz:
al = alwert / 1000000
w = SQR(l / al)
PRINT
PRINT "Die Spule hat"; w; "Windungen bei"; l; "Henry."
PRINT
GOTO grunz
REM ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
weisnichtalwert:
PRINT
PRINT "Den AL-Wert kann man berechnen, wenn man die Windungszahl einer"
PRINT "Muster-Spule und den Induktivittswert kennt."
PRINT
INPUT "Wieviele Windungen hat die Muster-Spule"; windelwickel
INPUT "Welche Induktivitt in Henry hat die Muster-Spule"; windelwahn
windelindukto = windelwahn * 1000000
alwert = windelindukto / (windelwickel * windelwickel)
PRINT
PRINT "Der AL-Wert betrgt"; alwert; "H/w."
PRINT "Der AL-Wert betrgt"; alwert * 1000; "nH/w."
GOTO donnerblitz
grunz:
INPUT "Mchten Sie zurck zum Anfang (j) oder alles beenden (n)"; baller$
IF baller$ = "j" THEN GOTO nimmersatt
IF baller$ = "n" THEN GOTO schluss
END
REM ########################################################################
swing:
CLS
PRINT "         Berechnungen am Parallel- und Serienschwingkreis"
PRINT "====================================================================="
CONST pi = 3.1415927#
PRINT "PARALLEL/SERIEN-SCHWINGKREIS"
PRINT "Mchten Sie die Frequenz, Kapazitt oder Induktivitat"
INPUT "berechnen (f/k/i)"; a$
PRINT
IF a$ = "f" GOTO frequenz
IF a$ = "k" GOTO kapazitet
IF a$ = "i" GOTO induktivitet
END
frequenz:
PRINT "FREQUENZ-BERECHNUNG"
INPUT "Wie gro ist die Kapazitt in Farad   "; c
INPUT "Wie gro ist die Induktivitt in Henry"; l
f = 1 / (2 * pi * SQR(c * l))
PRINT
PRINT "Die Resonanzfrequenz betrgt"; f; "Hz"
PRINT
GOTO anfang
kapazitet:
PRINT "KAPAZITTS-BERECHNUNG"
INPUT "Wie hoch ist die Frequenz in Hz       "; f
INPUT "Wie gro ist die Induktivitt in Henry"; l
c = 1 / ((f * 2 * pi) ^ 2 * l)
PRINT
PRINT "Die Kapazitt betrgt"; c; "Farad"
PRINT
GOTO anfang
induktivitet:
PRINT "INDUKTIVITTS-BERECHNUNG"
INPUT "Wie hoch ist die Frequenz in Hz       "; f
INPUT "Wie gro ist die Kapazitt in Farad   "; c
l = 1 / ((f * 2 * pi) ^ 2 * c)
PRINT
PRINT "Die Induktivitt betrgt"; l; "Henry"
PRINT
anfang:
PRINT
INPUT "Mchten Sie zurck zum Programmanfang (j/n)"; c$
IF c$ = "j" THEN GOTO nimmersatt
PRINT "Mchten Sie das Programm beenden (j) oder"
INPUT "die Verluste des Kreises berechnen (n)"; d$
IF d$ = "j" THEN GOTO schluss
CLS
PRINT "VERLUSTE IM SCHWINGKREIS"
PRINT
PRINT "Bisher wurden Berechnungen am idealen Schwingkreis vorgenommen. Jetzt"
PRINT "werden zustzlich die Verluste bercksichtigt. Handelte es sich bei"
INPUT "obiger Berechnung um einen Parallel- oder Serienschwingkreis (p/s)"; e$
IF e$ = "p" THEN GOTO pa
IF e$ = "s" THEN GOTO se
END
REM #######################################################################
pa:
CLS
PRINT "VERLUSTE IM PARALLEL-SCHWINGKREIS"
PRINT
PRINT "Welche der folgenden Grssen ist Ihnen bekannt?"
PRINT
PRINT "       1  Bandbreite                4  Verlustfaktor"
PRINT "       2  Gte                      5  Verlustwiderstand der Spule"
PRINT "       3  Resonanzwiderstand        6  Programm beenden"
PRINT
INPUT "Geben Sie die entsprechende Nummer ein"; pan
IF pan = 1 THEN GOTO pan1
IF pan = 2 THEN GOTO pan2
IF pan = 3 THEN GOTO pan3
IF pan = 4 THEN GOTO pan4
IF pan = 5 THEN GOTO pan5
IF pan = 6 THEN GOTO schluss
pan1:
INPUT "Geben Sie die Bandbreite in Hz ein"; b
q = f / b
d = 1 / q
z = (2 * pi * f * l) * q
rv = l / (z * c)
PRINT
PRINT "Die Gte ist"; q
PRINT "Der Resonanzwiderstand des Kreises hat"; z; "Ohm"
PRINT "Der Verlustfaktor des Kreises betrgt"; d
PRINT "Der Verlustwiderstand der Spule hat"; rv; "Ohm"
GOTO paff
pan2:
INPUT "Geben Sie die Kreisgte ein"; q
b = f / q
d = 1 / q
z = (2 * pi * f * l) * q
rv = l / (z * c)
PRINT
PRINT "Die Bandbreite betrgt"; b; "Hz"
PRINT "Der Resonanzwiderstand des Kreises hat"; z; "Ohm"
PRINT "Der Verlustfaktor des Kreises betrgt"; d
PRINT "Der Verlustwiderstand der Spule hat"; rv; "Ohm"
GOTO paff
pan3:
INPUT "Geben Sie den Resonanzwiderstand des Kreises in Ohm ein"; z
q = z / (2 * pi * f * l)
b = f / q
d = 1 / q
rv = l / (z * c)
PRINT
PRINT "Die Gte ist"; q
PRINT "Die Bandbreite betrgt"; b; "Hz"
PRINT "Der Verlustfaktor des Kreises betrgt"; d
PRINT "Der Verlustwiderstand der Spule hat"; rv; "Ohm"
GOTO paff
pan4:
INPUT "Geben Sie den Verlustfaktor des Kreises an"; d
q = 1 / d
b = f / q
z = (2 * pi * f * l) * q
rv = l / (z * c)
PRINT
PRINT "Die Gte ist"; q
PRINT "Die Bandbreite betrgt"; b; "Hz"
PRINT "Der Verlustwiderstand der Spule hat"; rv; "Ohm"
PRINT "Der Resonanzwiderstand des Kreises hat"; z; "Ohm"
GOTO paff
pan5:
INPUT "Geben Sie den Verlustwiderstand der Spule in Ohm ein"; rv
z = l / (rv * c)
q = z / (2 * pi * f * l)
b = f / q
d = 1 / q
PRINT
PRINT "Die Gte ist"; q
PRINT "Die Bandbreite betrgt"; b; "Hz"
PRINT "Der Resonanzwiderstand des Kreises hat"; z; "Ohm"
PRINT "Der Verlustfaktor des Kreises betrgt"; d
GOTO paff
REM #######################################################################
se:
CLS
PRINT "VERLUSTE IM SERIEN-SCHWINGKREIS"
PRINT
PRINT "Welche der folgenden Grssen ist Ihnen bekannt?"
PRINT
PRINT "       1  Bandbreite                4  Verlustfaktor"
PRINT "       2  Gte                      5  Verlustwiderstand der Spule"
PRINT "       3  Resonanzwiderstand        6  Programm beenden"
PRINT
INPUT "Geben Sie die entsprechende Nummer ein"; sen
PRINT
IF sen = 1 THEN GOTO sen1
IF sen = 2 THEN GOTO sen2
IF sen = 3 THEN GOTO sen3
IF sen = 4 THEN GOTO sen4
IF sen = 5 THEN GOTO sen5
IF sen = 6 THEN GOTO schluss
sen1:
INPUT "Geben Sie die Bandbreite in Hz ein"; b
q = f / b
d = 1 / q
z = (2 * pi * f * l) / q
rv = z
PRINT
PRINT "Die Gte ist"; q
PRINT "Der Resonanzwiderstand des Kreises hat"; z; "Ohm"
PRINT "Der Verlustfaktor des Kreises betrgt"; d
PRINT "Der Verlustwiderstand der Spule hat"; rv; "Ohm"
GOTO saft
sen2:
INPUT "Geben Sie die Kreisgte ein"; q
b = f / q
d = 1 / q
z = (2 * pi * f * l) / q
rv = z
PRINT
PRINT "Die Bandbreite betrgt"; b; "Hz"
PRINT "Der Resonanzwiderstand des Kreises hat"; z; "Ohm"
PRINT "Der Verlustfaktor des Kreises betrgt"; d
PRINT "Der Verlustwiderstand der Spule hat"; rv; "Ohm"
GOTO saft
sen3:
INPUT "Geben Sie den Resonanzwiderstand des Kreises in Ohm ein"; z
rv = z
q = (2 * pi * f * l) / z
b = f / q
d = 1 / q
PRINT
PRINT "Die Gte ist"; q
PRINT "Die Bandbreite betrgt"; b; "Hz"
PRINT "Der Verlustfaktor des Kreises betrgt"; d
PRINT "Der Verlustwiderstand der Spule hat"; rv; "Ohm"
GOTO saft
sen4:
INPUT "Geben Sie den Verlustfaktor des Kreises an"; d
q = 1 / d
b = f / q
z = (2 * pi * f * l) / q
rv = z
PRINT
PRINT "Die Gte ist"; q
PRINT "Die Bandbreite betrgt"; b; "Hz"
PRINT "Der Verlustwiderstand der Spule hat"; rv; "Ohm"
PRINT "Der Resonanzwiderstand des Kreises hat"; z; "Ohm"
GOTO saft
sen5:
INPUT "Geben Sie den Verlustwiderstand der Spule in Ohm ein"; rv
z = rv
q = (2 * pi * f * l) / z
b = f / q
d = 1 / q
PRINT
PRINT "Die Gte ist"; q
PRINT "Die Bandbreite betrgt"; b; "Hz"
PRINT "Der Resonanzwiderstand des Kreises hat"; z; "Ohm"
PRINT "Der Verlustfaktor des Kreises betrgt"; d
GOTO saft
REM ########################################################################
paff:
PRINT
PRINT "Interessieren Sie sich fr die Spannungen und Strme"
INPUT "im Parallelschwingkreis (j/n)"; paff$
IF paff$ = "j" THEN GOTO paffr
IF paff$ = "n" THEN GOTO anfang
paffr:
PRINT
INPUT "Welche Spannung in Volt liegt am Schwingkreis an"; up
PRINT
ip = up / z
ipl = q * ip
PRINT "Dem Schwingkreis fliet ein Strom von"; ip; "A zu."
PRINT "Durch Kondensator und Spule fliet ein Strom von"; ipl; "A"
GOTO anfang
REM ########################################################################
saft:
PRINT
PRINT "Interessieren Sie sich fr die Spannungen und Strme"
INPUT "im Serienschwingkreis (j/n)"; saft$
IF saft$ = "j" THEN GOTO saftr
IF paff$ = "n" THEN GOTO anfang
saftr:
PRINT
INPUT "Welche Spannung in Volt liegt am Schwingkreis an"; us
PRINT
usl = q * us
PRINT "An Spule und Kondensator liegt jeweils ein Spannung"
PRINT "von"; usl; "Volt an."
GOTO anfang
REM ########################################################################
schluss:
PRINT
PRINT "P R O G R A M M - E N D E"
SYSTEM

